package io

import portal._

import java.util.Calendar
import scala.io.Source
import java.io._
import java.text.DecimalFormat

class Writer(private var _ufes: Universidade){

    var df = new DecimalFormat("0.00")

    def imprimePautaFinal(folder: String) = {

        for(d <- _ufes.disciplinas)
        {
            val pw = new PrintWriter(new File(folder + "1-pauta-" + d.codigo + ".csv" ))

            //Avaliacoes definidas para a disciplina atual
            val avaliacoes = d.avaliacoes

            //Imprime cabecalho
            pw.write("Matrícula;Aluno;")
            for(ava <- avaliacoes
                if !ava.ehFinal)
                pw.write(ava.codigo + ";")
            pw.write("Média Parcial;Prova Final;Média Final\n")

            var alunos = d.alunos
            var i = 0
            for(a <- alunos)
            {
                pw.write(a.matricula.toString + ";" + a.nome + ";")

                var mediaParcial = 0.0
                var sumPesos = 0.0
                var pFinal: Option[Double] = None

                for(ava <- avaliacoes)
                {
                    ava.ehTrabalho match {
                        case true => {
                            ava.asInstanceOf[Trabalho].getNotaAluno(a) match {
                                case Some(n) => {
                                    pw.write(df.format(n.nota) + ";")
                                    mediaParcial += n.nota * ava.peso
                                    sumPesos += ava.peso
                                }
                                case _ => pw.write("-;")
                            }
                        }
                        case false => {
                            ava.ehFinal match {
                                case true => a.getNota(ava.codigo) match {
                                    case Some(n) => pFinal = Some(n.nota)
                                    case _ => ;
                                }
                                case false => a.getNota(ava.codigo) match {
                                    case Some(n) => {
                                        pw.write(df.format(n.nota) + ";")
                                        mediaParcial += n.nota * ava.peso
                                        sumPesos += ava.peso
                                    }
                                    case _ => pw.write("-;")
                                }                                
                            }
                        }
                    }
                }

                mediaParcial /= sumPesos

                pw.write(df.format(mediaParcial) + ";")
                pFinal match {
                    case Some(n) => {
                        pw.write(df.format(n) + ";")
                        pw.write( if(mediaParcial > 7.0) df.format(mediaParcial) else df.format((mediaParcial + n)/2) )
                    }
                    case _ => pw.write("-;" + df.format(mediaParcial))
                }

                //Ultima linha nao printa \n
                i = i + 1
                if(i < alunos.size)
                    pw.write("\n")
            }

            pw.close
        }

    }

}