package portal

abstract class Aluno extends Ordered[Aluno] {

	var _matricula: Int
	var _nome: String
	var _notas = Map[String, Nota]()

	override def toString = _nome

	//Getters e Setters
    def matricula = _matricula
    def matricula_=(value: Int) = _matricula = value

    def nome = _nome
    def nome_=(value: String) = _nome = value

    def addNota(nota: Nota) = {

    	_notas.get(nota.avaliacao.codigo) match {
          case Some(_) =>
            throw new IllegalArgumentException("Nota repetida para o aluno " + _matricula +
            " na avaliacao: " + nota.avaliacao.codigo + " .")
          case None =>
            _notas += (nota.avaliacao.codigo -> nota)
        }

    }

    def getNota(codAva: String) = _notas.get(codAva)

    def compare (that: Aluno) = this.nome.compare(that.nome)
}