package portal

import java.util.Calendar

abstract class Avaliacao extends Ordered[Avaliacao] {
	var _codigo: String
	var _nome: String
	var _peso: Double
	var _data: Calendar

	//Metodos abstratos a serem definidos
	def ehTrabalho: Boolean
	def ehFinal: Boolean

	if(peso <= 0)
		throw new IllegalArgumentException("Peso de avaliação inválido para " + _codigo + ": " + _peso + ".")

	override def toString = _nome

	//Getters e Setters
	def codigo = _codigo
	def codigo_=(value: String) = _codigo = value

	def nome = _nome
	def nome_=(value: String) = _nome = value

	def peso = _peso
	def peso_=(value: Double) = _peso = value

	def data = _data
	def data_=(value: Calendar) = _data = value

	def dataFormatada = _data.get(Calendar.DAY_OF_MONTH) + "/" + _data.get(Calendar.MONTH) + "/" + _data.get(Calendar.YEAR)

	def compare (that: Avaliacao) = this.data.compareTo(that.data)
}