package portal

class Disciplina(private var _codigo: String, private var _nome: String) {

	var _avaliacoes = Map[String, Avaliacao]() //Codigo, Objeto Avaliacao
    var _alunos = Map[Int, Aluno]() //Matricula, Objeto Aluno

	override def toString = _nome + ";" + _codigo;

	//Getters e Setters
    def codigo = _codigo
    def codigo_=(value: String) = _codigo = value

    def nome = _nome
    def nome_=(value: String) = _nome = value

    def alunos = _alunos.values.toList.sorted

    def avaliacoes = _avaliacoes.values.toList.sorted

    def addAvaliacao(ava: Avaliacao) = {

        _avaliacoes.get(ava.codigo) match {
          case Some(_) =>
            throw new IllegalArgumentException("Código repetido para avaliação: " + ava.codigo + ".")
          case None =>
            _avaliacoes += (ava.codigo -> ava)
        }

    }

    def getAvaliacao(codAva: String) = _avaliacoes.get(codAva)

    def getAluno(mat: Int) = _alunos.get(mat)

    def AddAluno(a: Aluno) = {

        _alunos.get(a.matricula) match {
          case Some(_) =>
            throw new IllegalArgumentException("Matrícula repetida para aluno: " + a.matricula + ".")
          case None =>
            _alunos += (a.matricula -> a)
        }

    }
    
    def qtdAvaliacoes = _avaliacoes.size
}