package portal

import java.util.Calendar

class Grupo(private var _nota: Nota, private var _alunos: List[Aluno] = List() ){

    //Getters e Setters
    def alunos = _alunos

    def nota = _nota
    def nota_=(value: Nota) = _nota = value

    def tamanho = _alunos.size

    def alunoRepetido(g: Grupo): Option[Aluno] = {

        for(a <- g.alunos)
            _alunos.find(x => x.matricula ==  a.matricula) match {
                case Some(al) => return Some(al)
                case _ => ;
            }

        return None

    }

    def addAluno(a: Aluno) = {

        _alunos.find(x => x.matricula ==  a.matricula) match {
            case Some(_) =>
                throw new IllegalStateException("O aluno " + a.matricula +" já está registrado no grupo.")
            case None =>
                _alunos = _alunos :+ a
        }

    }

    def getNotaAluno(a: Aluno): Option[Nota] = _alunos.find(x => x.matricula == a.matricula) match {
        case Some(_) => return Some(_nota)
        case _ => return None
    }
}