package portal

import java.util.Calendar

class Trabalho(var _codigo: String, var _nome: String, var _peso: Double, var _data: Calendar,
    private var _numMaxAlunos: Int) extends Avaliacao{

	private var _grupos = List[Grupo]()

	if(numMaxAlunos <= 0)
		throw new IllegalArgumentException("Tamanho máximo de grupo inválido para trabalho " + _codigo + ": " + _numMaxAlunos + ".")

    //Getters e Setters
    def numMaxAlunos = _numMaxAlunos
    def numMaxAlunos_=(value: Int) = _numMaxAlunos = value

    def addGrupo(g: Grupo) = {
    	if(g.tamanho > _numMaxAlunos)
    		throw new IllegalStateException("Tamanho de grupo maior que máximo(" + _numMaxAlunos + ") para trabalho " + _codigo + ": " + g.tamanho + ".")

    	//Lanca excecao caso tenha aluno repetido
    	for(grupo <- _grupos)
    		grupo.alunoRepetido(g) match {
                case Some(al) =>
                	throw new IllegalStateException("O aluno " + al.matricula +" foi registrado em mais de um grupo para a avaliação " + _codigo + ".")
            	case _ => ;
            }

    	_grupos = _grupos :+ g
    }

    def getNotaAluno(a: Aluno): Option[Nota] = {
        for(g <- _grupos)
            g.getNotaAluno(a) match {
                case Some(n) => return Some(n)
                case _ => ;
            }

        return None
    }

    def ehTrabalho = true
    def ehFinal = false
}